package laboratoire4.game;

import laboratoire4.IPawn;
import laboratoire4.Player;

import java.util.Arrays;
import java.util.Collection;
import java.util.Objects;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class GameUtils {
    public static <T extends IPawn> Stream<T> getPawnsAsStream(T[][] board) {
        return Arrays.stream(board)
                .flatMap(Arrays::stream)
                .filter(Objects::nonNull);
    }

    public static <T extends IPawn> Collection<IPawn> getPawns(T[][] board) {
        return getPawnsAsStream(board).collect(Collectors.toList());
    }

    public static <T extends IPawn> Stream<T> getMaxPawnsAsStream(T[][] board, Player player) {
        return getPawnsAsStream(board).filter(p -> p.getPlayer() == player);
    }

    public static <T extends IPawn> Collection<T> getMaxPawns(T[][] board, Player player) {
        return getMaxPawnsAsStream(board, player).collect(Collectors.toList());
    }

    public static <T extends IPawn> Stream<T> getMinPawnsAsStream(T[][] board, Player player) {
        return getPawnsAsStream(board).filter(p -> p.getPlayer() != player);
    }

    public static <T extends IPawn> Collection<T> getMinPawns(T[][] board, Player player) {
        return getMinPawnsAsStream(board, player).collect(Collectors.toList());
    }
}
