package laboratoire4.pawns;

import laboratoire4.IPawn;
import laboratoire4.Player;

public class Pushed extends Pawn {
    public Pushed(Player player, int row, int col) {
        super(player, row, col);
    }

    @Override
    public boolean isPusher() {
        return false;
    }

    @Override
    public boolean isMoveReallyValid(IPawn[][] board, PawnMovement movement, int fromRow, int fromCol, boolean ignorePlayers) {
        int direction = getDirection();
        IPawn pusher = null;
        IPawn to = board[fromRow + direction][fromCol + movement.getMove()];

        if (fromCol > 0 && movement == PawnMovement.RIGHT_DIAGONAL) {
            pusher = board[fromRow - direction][fromCol - movement.getMove()];
        } else if (fromCol < board.length - 1 && movement == PawnMovement.LEFT_DIAGONAL) {
            pusher = board[fromRow - direction][fromCol - movement.getMove()];
        } else if (movement == PawnMovement.STRAIGHT) {
            pusher = board[fromRow - direction][fromCol];
        }

        boolean pusherValid = pusher != null && pusher.isPusher() && pusher.getPlayer() == player;
        boolean destinationValid = to == null || (movement != PawnMovement.STRAIGHT && (ignorePlayers || to.getPlayer() != this.player));
        return pusherValid && destinationValid;
    }

    @Override
    public String toString() {
        return String.format("Pushed{%s, %s}", player, getPosition());
    }
}
