package laboratoire4.pawns;

import laboratoire4.Player;

import java.util.Stack;

public class SimulatedPusher extends Pusher implements SimulatedPawn {
    private final int originalRow;
    private final int originalCol;
    private final Stack<PawnMovement> previousMoves = new Stack<>();
    private int moveCount = 0;

    public SimulatedPusher(Player player, int row, int col) {
        super(player, row, col);

        originalRow = row;
        originalCol = col;
    }

    @Override
    public void move(PawnMovement movement) {
        previousMoves.push(movement);
        super.move(movement);
        moveCount++;
    }

    @Override
    public void revertMove() {
        PawnMovement move = previousMoves.pop();
        setRow(row - getDirection());
        setCol(col - move.getMove());
        moveCount--;
    }

    @Override
    public int getOriginalRow() {
        return originalRow;
    }

    @Override
    public int getOriginalCol() {
        return originalCol;
    }

    @Override
    public int getMoveCount() {
        return moveCount;
    }
}
